package com.propertyManagement.business.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.propertyManagement.common.utils.StringUtils;
import com.propertyManagement.common.core.page.TableDataInfo;
import com.propertyManagement.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.propertyManagement.business.domain.bo.ConvenienceServiceBo;
import com.propertyManagement.business.domain.vo.ConvenienceServiceVo;
import com.propertyManagement.business.domain.ConvenienceService;
import com.propertyManagement.business.mapper.ConvenienceServiceMapper;
import com.propertyManagement.business.service.IConvenienceServiceService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 便民服务Service业务层处理
 *
 * @author Ashe
 * @date 2025-08-13
 */
@RequiredArgsConstructor
@Service
public class ConvenienceServiceServiceImpl implements IConvenienceServiceService {

    private final ConvenienceServiceMapper baseMapper;

    /**
     * 查询便民服务
     */
    @Override
    public ConvenienceServiceVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询便民服务列表
     */
    @Override
    public TableDataInfo<ConvenienceServiceVo> queryPageList(ConvenienceServiceBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ConvenienceService> lqw = buildQueryWrapper(bo);
        Page<ConvenienceServiceVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询便民服务列表
     */
    @Override
    public List<ConvenienceServiceVo> queryList(ConvenienceServiceBo bo) {
        LambdaQueryWrapper<ConvenienceService> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ConvenienceService> buildQueryWrapper(ConvenienceServiceBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ConvenienceService> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getServiceType() != null, ConvenienceService::getServiceType, bo.getServiceType());
        lqw.like(StringUtils.isNotBlank(bo.getDescription()), ConvenienceService::getDescription, bo.getDescription());
        lqw.like(StringUtils.isNotBlank(bo.getBookPhone()), ConvenienceService::getBookPhone, bo.getBookPhone());
        return lqw;
    }

    /**
     * 新增便民服务
     */
    @Override
    public Boolean insertByBo(ConvenienceServiceBo bo) {
        ConvenienceService add = BeanUtil.toBean(bo, ConvenienceService.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改便民服务
     */
    @Override
    public Boolean updateByBo(ConvenienceServiceBo bo) {
        ConvenienceService update = BeanUtil.toBean(bo, ConvenienceService.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ConvenienceService entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除便民服务
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
